All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
AmoebaGeneralizedKirkwoodForce Class Reference

This class implements an implicit solvation force using the generalized Kirkwood/Grycuk model. More...

`#include <AmoebaGeneralizedKirkwoodForce.h>`

Inheritance diagram for AmoebaGeneralizedKirkwoodForce:

## Public Member Functions

| AmoebaGeneralizedKirkwoodForce ()
int | getNumParticles () const
| Get the number of particles in the system. More...
int | addParticle (double charge, double radius, double scalingFactor)
| Add the parameters for a particle. More...
void | getParticleParameters (int index, double &charge, double &radius, double &scalingFactor) const
| Get the force field parameters for a particle. More...
void | setParticleParameters (int index, double charge, double radius, double scalingFactor)
| Set the force field parameters for a particle. More...
double | getSolventDielectric () const
| Get the dielectric constant for the solvent. More...
void | setSolventDielectric (double dielectric)
| Set the dielectric constant for the solvent. More...
double | getSoluteDielectric () const
| Get the dielectric constant for the solute. More...
void | setSoluteDielectric (double dielectric)
| Set the dielectric constant for the solute. More...
int | getIncludeCavityTerm () const
| Get the flag signaling whether the cavity term should be included. More...
void | setIncludeCavityTerm (int includeCavityTerm)
| Set the flag signaling whether the cavity term should be included. More...
double | getProbeRadius () const
| Get the probe radius (nm) used in SASA contribution. More...
void | setProbeRadius (double probeRadius)
| Set the probe radius (nm) used in SASA contribution. More...
double | getSurfaceAreaFactor () const
| Get the surface area factor kJ/(nm*nm) used in SASA contribution. More...
void | setSurfaceAreaFactor (double surfaceAreaFactor)
| Set the surface area factor kJ/(nm*nm) used in SASA contribution. More...
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class implements an implicit solvation force using the generalized Kirkwood/Grycuk model.

To use this class, create an AmoebaGeneralizedKirkwoodForce object, then call addParticle() once for each particle in the System to define its parameters. The number of particles for which you define parameters must be equal to the number of particles in the System, or else an exception will be thrown when you try to create a Context. After a particle has been added, you can modify its force field parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaGeneralizedKirkwoodForce | ( |  | ) |

## Member Function Documentation

int addParticle | ( | double | charge,
|  | double | radius,
|  | double | scalingFactor
| ) |  |

Add the parameters for a particle.

This should be called once for each particle in the System. When it is called for the i'th time, it specifies the parameters for the i'th particle.

Parameters

  charge | the charge of the particle, measured in units of the proton charge
  radius | the atomic radius of the particle, measured in nm
  scalingFactor | the scaling factor for the particle

Returns
  the index of the particle that was added

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getIncludeCavityTerm | ( |  | ) | const

Get the flag signaling whether the cavity term should be included.

int getNumParticles | ( |  | ) | const

inline

Get the number of particles in the system.

void getParticleParameters | ( | int | index,
|  | double & | charge,
|  | double & | radius,
|  | double & | scalingFactor
| ) |  | const

Get the force field parameters for a particle.

Parameters

  index | the index of the particle for which to get parameters
  charge | the charge of the particle, measured in units of the proton charge
  radius | the atomic radius of the particle, measured in nm
  scalingFactor | the scaling factor for the particle

double getProbeRadius | ( |  | ) | const

Get the probe radius (nm) used in SASA contribution.

double getSoluteDielectric | ( |  | ) | const

inline

Get the dielectric constant for the solute.

double getSolventDielectric | ( |  | ) | const

inline

Get the dielectric constant for the solvent.

double getSurfaceAreaFactor | ( |  | ) | const

Get the surface area factor kJ/(nm*nm) used in SASA contribution.

void setIncludeCavityTerm | ( | int | includeCavityTerm | ) |

Set the flag signaling whether the cavity term should be included.

void setParticleParameters | ( | int | index,
|  | double | charge,
|  | double | radius,
|  | double | scalingFactor
| ) |  |

Set the force field parameters for a particle.

Parameters

  index | the index of the particle for which to set parameters
  charge | the charge of the particle, measured in units of the proton charge
  radius | the atomic radius of the particle, measured in nm
  scalingFactor | the scaling factor for the particle

void setProbeRadius | ( | double | probeRadius | ) |

Set the probe radius (nm) used in SASA contribution.

void setSoluteDielectric | ( | double | dielectric | ) |

inline

Set the dielectric constant for the solute.

void setSolventDielectric | ( | double | dielectric | ) |

inline

Set the dielectric constant for the solvent.

void setSurfaceAreaFactor | ( | double | surfaceAreaFactor | ) |

Set the surface area factor kJ/(nm*nm) used in SASA contribution.

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information this method updates is the values of per-particle parameters. All other aspects of the Force (the probe radius, the surface area factor, etc.) are unaffected and can only be changed by reinitializing the Context.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if nonbondedMethod uses PBC and false otherwise

Reimplemented from Force.

The documentation for this class was generated from the following file:

- AmoebaGeneralizedKirkwoodForce.h